/*
    Project: TCGINA
    Version: V1.23
    File   : kfdlg.h

    Copyright (c) 2005-2008 Author of TCGINA DLL. All rights reserved.
    Public Key Fingerprint: 294B A769 4A0A CC05 DAE6 00DD FF47 8C72 4097 67CE

    Covered by TrueCrypt License 2.3 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#ifndef __KFIDLG_H_D47DF546F16B490bA6D8523603A5594D
#define __KFIDLG_H_D47DF546F16B490bA6D8523603A5594D

#include "kfi.h"
#include "kfdlgrc.h"

#define KF_CACHE_SIZE 10

typedef struct {
    CHAR                 aszPassword[KFI_MAX_PASSWORD];
} KF_PASSWORD, *PKF_PASSWORD;

typedef struct {
    KFI_ENCRYPTION_DATA  kfiKeyData;
    KFI_DATA             kfiDecryptedData;
    KF_PASSWORD          rgPasswordCache[KF_CACHE_SIZE];
    CHAR                 aszPassword[KFI_MAX_PASSWORD];
    WCHAR                wszTempPassword[KFI_MAX_PASSWORD];
} KF_SEC_DATA, *PKF_SEC_DATA;

struct s_KF_ENTRY;
typedef struct s_KF_ENTRY KF_ENTRY, *PKF_ENTRY;
struct s_KF_ENTRY
{
    PKF_ENTRY            pNextEntry;

    KFI_DATA             kfiEncryptedData;
    DWORD                dwType;
    DWORD                dwID;
    TCHAR                szDescription[KFI_MAX_DESCRIPTION];

    DWORD                dwTag;
    BOOL                 fModified;
    BOOL                 fRandom;
};

#define KFET_UNKNOWN   0
#define KFET_PLAINTEXT 1
#define KFET_ENCRYPTED 2

typedef struct
{
    PKF_SEC_DATA         pSecData;
    TCHAR                szFileName[MAX_PATH];
#if 0
    LARGE_INTEGER        liFileOffset;
    DWORD                dwFileSize;
#endif
    HINSTANCE            hInstance;

    /* internal data */
    BOOL                 fModified;
    DWORD                dwCacheIndex;
    PKF_PASSWORD         pPasswordCache;
    PKFI_DATA            pkfiDecryptedData;
    PKFI_ENCRYPTION_DATA pkfiKeyData;
    LPSTR                paszPassword;
    LPWSTR               pwszTempPassword;

    PKF_ENTRY            pFirstEntry;
    PKF_ENTRY            pLastEntry;
    DWORD                dwCount;

    HWND                 hwndDlg;
    HWND                 hwndList;
    HCURSOR              hWaitCursor;
    HCURSOR              hArrowCursor;
    BOOL                 fInternalCall;

    DWORD                dwResult;

} KF_DIALOG_DATA, *PKF_DIALOG_DATA;

#ifdef __cplusplus
extern "C" {
#endif

INT_PTR CALLBACK KeyFileDialogProc(HWND hwndDlg, UINT uMsg,
  WPARAM wParam, LPARAM lParam);
BOOL KF_Edit(PKF_DIALOG_DATA pkfdd);

#ifdef __cplusplus
}
#endif

#endif
